<?php if (!defined('EMLOG_ROOT')) {
    exit('error!');
} ?>
<div class="container">
    <div class="row justify-content-center">
        <div class="col-xl-6 col-lg-10 col-md-9">
            <div class="card o-hidden border-0 shadow-lg my-5">
                <div class="card-body p-0">
                    <div class="row">
                        <div class="col-lg-12">
                            <div class="p-5">
                                <div class="text-center">
                                    <h1 class="h4 text-gray-900 mb-4">注册账号</h1>
                                </div>
                                <?php if (isset($_GET['err_ckcode'])): ?>
                                    <div class="alert alert-danger">验证错误，请重新输入</div><?php endif ?>
                                <?php if (isset($_GET['error_login'])): ?>
                                    <div class="alert alert-danger">错误的邮箱格式</div><?php endif ?>
                                <?php if (isset($_GET['error_exist'])): ?>
                                    <div class="alert alert-danger">该邮箱已被注册</div><?php endif ?>
                                <?php if (isset($_GET['error_pwd_len'])): ?>
                                    <div class="alert alert-danger">密码不小于6位</div><?php endif ?>
                                <?php if (isset($_GET['error_pwd2'])): ?>
                                    <div class="alert alert-danger">两次输入的密码不一致</div><?php endif ?>
                                <form method="post" class="user" action="./account.php?action=dosignup">
                                    <div class="form-group">
                                        <input type="email" class="form-control form-control-user" id="mail"
                                               name="mail" aria-describedby="emailHelp" placeholder="邮箱" required
                                               autofocus>
                                    </div>
                                    <?php if ($is_smsup): ?>
                                        <div class="form-group form-inline">
                                                <input  type="text" id="userPhone" class="form-control form-control-user" placeholder="请输入手机号码">
                                                <button  type="button" class="btn btn-info"  id="second">点击获取验证码</button>
                                        </div>
                                        <div class="form-group">
                                            <input type="text" name="securityCode" class="form-control form-control-user"  placeholder="请输入验证码" required autofocus>
                                        </div>
                                    <?php endif; ?>
                                    <div class="form-group">
                                        <input type="password" class="form-control form-control-user" minlength="6"
                                               id="passwd" name="passwd" placeholder="密码" required>
                                    </div>
                                    <div class="form-group">
                                        <input type="password" class="form-control form-control-user" minlength="6"
                                               id="repasswd" name="repasswd" placeholder="再次输入密码" required>
                                    </div>
                                    <?php if ($login_code): ?>
                                        <div class="form-group form-inline">
                                            <input type="text" name="login_code" class="form-control form-control-user"
                                                   id="login_code" placeholder="验证码" required>
                                            <img src="../include/lib/checkcode.php" id="checkcode" class="mx-2">
                                        </div>
                                    <?php endif ?>
                                    <button class="btn btn-success btn-user btn-block" type="submit">注册</button>
                                    <hr>
                                    <div class="text-center"><a href="/admin">登录</a></div>
                                    <hr>
                                    <div class="text-center"><a href="../" class="small" role="button">&larr;返回首页</a>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
</body>
</html>
<script>
    setTimeout(hideActived, 6000);
    $('#checkcode').click(function () {
        var timestamp = new Date().getTime();
        $(this).attr("src", "../include/lib/checkcode.php?" + timestamp);
    });
</script>
<script type="text/javascript">
    $("#second").click(function (){
        sendyzm($("#second"));
    });
    //用ajax提交到后台的发送短信接口
    function sendyzm(obj){
        var phone = $("#userPhone").val();
        var result = isPhoneNum();
        var login_code = $("#login_code").val();
        if(result) {
            $.ajax({
                url:"/admin/account.php?action=smsYzm&phone="+phone+'&login_code='+login_code,
                type:"get",
                processData: false,
                contentType: false,
                success:function(data){
                    if (data == 0) {
                        setTime(obj);
                    }else if (data == 1){
                        alert('验证码发送频繁')
                    }else if (data == 2){
                        alert('图形验证码错误')
                    }else{
                        alert('验证码发送失败')
                    }
                },
                error:function(){
                    alert("验证码发送失败")
                }
            })
        }
    }

    //60s倒计时实现逻辑
    var countdown = 60;
    function setTime(obj) {
        if (countdown == 0) {
            obj.prop('disabled', false);
            obj.text("点击获取验证码");
            countdown = 60;//60秒过后button上的文字初始化,计时器初始化;
            return;
        } else {
            obj.prop('disabled', true);
            obj.text("("+countdown+"s)后重新发送") ;
            countdown--;
        }
        setTimeout(function() { setTime(obj) },1000) //每1000毫秒执行一次
    }


    //校验手机号是否合法
    function isPhoneNum(){
        var phonenum = $("#userPhone").val();
        var reg = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1})|(17[0-9]{1}))+\d{8})$/;
        if(!reg.test(phonenum)){
            alert('请输入有效的手机号码！');
            return false;
        }else{
            return true;
        }
    }
</script>
